## apvlv 0.4.0+repack

=== src/CMakeLists.txt ===
ADD_COMPILE_OPTIONS(-std=c++11)

IF (WIN32)
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)
ELSE (WIN32)
    SET(CMAKE_CXX_FLAGS "-Wall -fno-strict-aliasing")

    OPTION(APVLV_ENABLE_DEBUG "If build binary with debug information." OFF)
    IF (APVLV_ENABLE_DEBUG)
        SET(CMAKE_CXX_FLAGS "-D_DEBUG -g ${CMAKE_CXX_FLAGS}")
    ELSE (APVLV_ENABLE_DEBUG)
        SET(CMAKE_CXX_FLAGS "-O2 ${CMAKE_CXX_FLAGS}")
    ENDIF (APVLV_ENABLE_DEBUG)
ENDIF (WIN32)

FIND_PACKAGE(PkgConfig)

PKG_CHECK_MODULES(FREETYPE2 freetype2 REQUIRED)
PKG_CHECK_MODULES(GTK gtk+-3.0)
PKG_CHECK_MODULES(GLIB2 glib-2.0 REQUIRED)
PKG_CHECK_MODULES(WEBKIT webkit2gtk-4.0 REQUIRED)
INCLUDE_DIRECTORIES(${FREETYPE2_INCLUDE_DIRS}
        ${GTK_INCLUDE_DIRS}
        ${GLIB2_INCLUDE_DIRS}
        ${WEBKIT_INCLUDE_DIRS})
LINK_DIRECTORIES(${FREETYPE2_LIBRARY_DIRS}
        ${GTK_LIBRARY_DIRS}
        ${GLIB2_LIBRARY_DIRS}
        ${WEBKIT_LIBRARY_DIRS})

IF (WIN32)
    SET(POPPLER_DIR ${CMAKE_HOME_DIRECTORY}/win32/poppler-src)

    INCLUDE_DIRECTORIES(${POPPLER_DIR})
    LINK_DIRECTORIES(${CMAKE_BINARY_DIR}/poppler-build)
    SET(APVLV_REQ_LIBRARIES poppler.lib freetype.lib)

    ADD_SUBDIRECTORY(${POPPLER_DIR} ${CMAKE_BINARY_DIR}/poppler-build)
ELSE (WIN32)
    PKG_CHECK_MODULES(POPPLER poppler-glib REQUIRED)
    INCLUDE_DIRECTORIES(${POPPLER_INCLUDE_DIRS})
    LINK_DIRECTORIES(${POPPLER_LIBRARY_DIRS})
    SET(APVLV_REQ_LIBRARIES ${POPPLER_LIBRARIES})
ENDIF (WIN32)

SET(HEADERS
        ApvlvCmds.h
        ApvlvCore.h
        ApvlvDoc.h
        ApvlvFile.h
        ApvlvPdf.h
        ApvlvInfo.h
        ApvlvMenu.h
        ApvlvParams.h
        ApvlvUtil.h
        ApvlvView.h
        ApvlvWindow.h
        ApvlvCompletion.h
        ApvlvHtm.h
        ApvlvEpub.h
        ApvlvContent.h
        )

SET(SOURCES
        ApvlvCmds.cc
        ApvlvCore.cc
        ApvlvDoc.cc
        ApvlvFile.cc
        ApvlvPdf.cc
        ApvlvInfo.cc
        ApvlvMenu.cc
        ApvlvParams.cc
        ApvlvUtil.cc
        ApvlvView.cc
        ApvlvWindow.cc
        ApvlvCompletion.cc
        ApvlvHtm.cc
        ApvlvEpub.cc
        ApvlvContent.cc
        main.cc
        )

OPTION(APVLV_WITH_DJVU "If build apvlv with djvu format support." OFF)
IF (APVLV_WITH_DJVU)
    ADD_DEFINITIONS(-DAPVLV_WITH_DJVU)

    IF (WIN32)
        SET(DJVULIBRE_DIR ${CMAKE_HOME_DIRECTORY}/win32/djvulibre)

        INCLUDE_DIRECTORIES(${DJVULIBRE_DIR}/include)
        LINK_DIRECTORIES(${DJVULIBRE_DIR})
        SET(APVLV_REQ_LIBRARIES libdjvulibre.lib
                ${APVLV_REQ_LIBRARIES})
    ELSE (WIN32)
        SET(APVLV_REQ_LIBRARIES -ldjvulibre
                ${APVLV_REQ_LIBRARIES})
    ENDIF (WIN32)

    SET(HEADERS ${HEADERS} ApvlvDjvu.h)
    SET(SOURCES ${SOURCES} ApvlvDjvu.cc)
ENDIF (APVLV_WITH_DJVU)

OPTION(APVLV_WITH_TXT "If build binary with txt format support." OFF)
IF (APVLV_WITH_TXT)
    ADD_DEFINITIONS(-DAPVLV_WITH_TXT)

    SET(HEADERS ${HEADERS} ApvlvTxt.h)
    SET(SOURCES ${SOURCES} ApvlvTxt.cc)
ENDIF (APVLV_WITH_TXT)

ADD_EXECUTABLE(apvlv ${HEADERS} ${SOURCES})

TARGET_LINK_LIBRARIES(apvlv
        ${GTK_LIBRARIES}
        ${GLIB2_LIBRARIES}
        ${GTHREAD2_LIBRARIES}
        ${WEBKIT_LIBRARIES}
        "-lepub"
        "-lxml2"
        ${APVLV_REQ_LIBRARIES})

IF (WIN32)
    ADD_DEPENDENCIES(apvlv poppler)
ENDIF (WIN32)

IF (WIN32)
    INSTALL(TARGETS apvlv DESTINATION .)
    FIND_FILE(LIBATK libatk-1.0-0.dll)
    FIND_FILE(LIBEXPAT1 libexpat-1.dll)
    FIND_FILE(LIBFONTCONFIG1 libfontconfig-1.dll)
    FIND_FILE(LIBGIO libgio-2.0-0.dll)
    FIND_FILE(LIBCAIRO libcairo-2.dll)
    FIND_FILE(LIBPANGOCAIRO libpangocairo-1.0-0.dll)
    FIND_FILE(LIBPANGOFT2 libpangoft2-1.0-0.dll)
    FIND_FILE(LIBGDKPIXBUF libgdk_pixbuf-2.0-0.dll)
    FIND_FILE(LIBGDK libgdk-win32-2.0-0.dll)
    FIND_FILE(LIBGLIB libglib-2.0-0.dll)
    FIND_FILE(LIBGMODULE libgmodule-2.0-0.dll)
    FIND_FILE(LIBPANGO libpango-1.0-0.dll)
    FIND_FILE(LIBGTHREAD libgthread-2.0-0.dll)
    FIND_FILE(LIBPNG libpng14-14.dll)
    FIND_FILE(LIBGTK libgtk-win32-2.0-0.dll)
    FIND_FILE(LIBGOBJECT libgobject-2.0-0.dll)
    FIND_FILE(LIBPANGOWIN32 libpangowin32-1.0-0.dll)
    FIND_FILE(LIBZLIB1 zlib1.dll)
    FIND_FILE(FREETYPE6 freetype6.dll)
    INSTALL(FILES
            ${LIBATK}
            ${LIBEXPAT1}
            ${LIBFONTCONFIG1}
            ${LIBGIO}
            ${LIBCAIRO}
            ${LIBPANGOCAIRO}
            ${LIBGDKPIXBUF}
            ${LIBGDK}
            ${LIBGLIB}
            ${LIBGMODULE}
            ${LIBPANGO}
            ${LIBGTHREAD}
            ${LIBPNG}
            ${LIBGTK}
            ${LIBGOBJECT}
            ${LIBPANGOFT2}
            ${LIBPANGOWIN32}
            ${LIBZLIB1}
            ${FREETYPE6}
            DESTINATION .)
    IF (APVLV_WITH_DJVU)
        INSTALL(FILES
                ${DJVULIBRE_DIR}/libdjvulibre.dll
                ${DJVULIBRE_DIR}/libjpeg.dll
                DESTINATION .)
    ENDIF (APVLV_WITH_DJVU)
ELSE (WIN32)
    INSTALL(TARGETS apvlv DESTINATION bin)
ENDIF (WIN32)

=== debian/changelog ===
apvlv (0.4.0+repack-2) unstable; urgency=medium

  * Bump Standards-Version: 4.6.2
  * d/rules: add execute_before_dh_auto_build execute_after_dh_builddeb target
    (Closes: #1043628)
  * d/copyright: update year info to 2023
  * Run wrap-and-sort -asbkt

 -- xiao sheng wen <atzlinux@sina.com>  Tue, 15 Aug 2023 17:08:48 +0800

apvlv (0.4.0+repack-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on cmake and libpoppler-glib-dev.
    + apvlv: Drop versioned constraint on poppler-data in Suggests.

  [ xiao sheng wen ]
  * New maintainer (Closes: #798945)
  * Use secure URI in Homepage field.
  * Fix day-of-week for changelog entry 0.0.7.3-1.
  * d/control:
      - add Provides: pdf-viewer(Closes: #734657)
      - use mandoc to get Startup.pdf, pass the reprotest
      - add Rules-Requires-Root: no
  * d/copyright:
      - add 2022 xiao sheng wen <atzlinux@sina.com>
      - update the upstream year info to 2021
  * d/upstream/metadata: add Repository: and Repository-Browse: fields
  * Bump Standards-Version: 4.6.1.0
  * d/watch: add repacksuffix=+repack
  * import upstream repack suffix version 0.4.0+repack
  * d/mime: fix typo, add one space before word "priority"
  * d/rules: remove -DAPVLV_WITH_UMD=OFF,useless in the current upstream version

 -- xiao sheng wen <atzlinux@sina.com>  Tue, 19 Jul 2022 15:17:38 +0800

=== debian/control ===
Source: apvlv
Section: text
Priority: optional
Maintainer: xiao sheng wen <atzlinux@sina.com>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 ghostscript,
 libdjvulibre-dev,
 libepub-dev,
 libgtk-3-dev,
 libpoppler-glib-dev,
 libpoppler-private-dev,
 libwebkit2gtk-4.0-dev,
 libxml2-dev,
 mandoc,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://naihe2010.github.io/apvlv/
Vcs-Git: https://salsa.debian.org/debian/apvlv.git
Vcs-Browser: https://salsa.debian.org/debian/apvlv

Package: apvlv
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 pdf-viewer,
Suggests:
 poppler-data,
Description: PDF viewer with Vim-like behaviour
 apvlv (Alf's PDF Viewer Like Vim) is a small and fast PDF viewer, that uses
 poppler for rendering. Its interface aims to users who like vim behaviour.
 For example opening a PDF file can be done with ':o filename'. apvlv can also
 work with tabs, so you can open multiple files at the same time in one
 program.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DAPVLV_WITH_TXT=ON

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_compress:
	dh_compress -XStartup.pdf

execute_before_dh_auto_build:
	cp -v Startup.pdf debian/orig.Startup.pdf

execute_before_dh_installdocs:
	mandoc -T pdf apvlv.1 > Startup.pdf

execute_after_dh_builddeb:
	mv -v debian/orig.Startup.pdf Startup.pdf

# cmake is a nice way to install this package's files, but it gets a
# few things wrong.  We run dh_auto_install and then tidy up.  Also
# see the d/install file.
execute_after_dh_auto_install:
	mv debian/apvlv/usr/share/doc/apvlv/apvlvrc.example \
		debian/apvlv/usr/share/doc/apvlv/examples/
	mv debian/apvlv/usr/share/doc/apvlv/main_menubar.glade \
		debian/apvlv/usr/lib/apvlv/
	rm -r debian/apvlv/usr/share/doc/apvlv/icons/

## apvlv 0.5.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -18,14 +18,20 @@
 PKG_CHECK_MODULES(FREETYPE2 freetype2 REQUIRED)
 PKG_CHECK_MODULES(GTK gtk+-3.0)
 PKG_CHECK_MODULES(GLIB2 glib-2.0 REQUIRED)
-PKG_CHECK_MODULES(WEBKIT webkit2gtk-4.0 REQUIRED)
+PKG_CHECK_MODULES(LIBXML libxml-2.0 REQUIRED)
+PKG_CHECK_MODULES(WEBKIT webkit2gtk-4.1)
+if (NOT WEBKIT_FOUND)
+  PKG_CHECK_MODULES(WEBKIT webkit2gtk-4.0 REQUIRED)
+endif()
 INCLUDE_DIRECTORIES(${FREETYPE2_INCLUDE_DIRS}
         ${GTK_INCLUDE_DIRS}
         ${GLIB2_INCLUDE_DIRS}
+        ${LIBXML_INCLUDE_DIRS}
         ${WEBKIT_INCLUDE_DIRS})
 LINK_DIRECTORIES(${FREETYPE2_LIBRARY_DIRS}
         ${GTK_LIBRARY_DIRS}
         ${GLIB2_LIBRARY_DIRS}
+        ${LIBXML_LIBRARY_DIRS}
         ${WEBKIT_LIBRARY_DIRS})
 
 IF (WIN32)
@@ -50,7 +56,7 @@
         ApvlvFile.h
         ApvlvPdf.h
         ApvlvInfo.h
-        ApvlvMenu.h
+        ApvlvMenuAndTool.h
         ApvlvParams.h
         ApvlvUtil.h
         ApvlvView.h
@@ -68,7 +74,7 @@
         ApvlvFile.cc
         ApvlvPdf.cc
         ApvlvInfo.cc
-        ApvlvMenu.cc
+        ApvlvMenuAndTool.cc
         ApvlvParams.cc
         ApvlvUtil.cc
         ApvlvView.cc
@@ -116,7 +122,7 @@
         ${GTHREAD2_LIBRARIES}
         ${WEBKIT_LIBRARIES}
         "-lepub"
-        "-lxml2"
+        ${LIBXML_LIBRARIES}
         ${APVLV_REQ_LIBRARIES})
 
 IF (WIN32)

## apvlv 0.5.0+repack

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.1)
SET(CMAKE_CXX_STANDARD 11)
SET(CMAKE_EXPORT_COMPILE_COMMANDS 1)

PROJECT(apvlv)

SET(PROJECT_MAJOR "0")
SET(PROJECT_MINOR "5")
SET(PROJECT_PATCH "0")
FIND_PACKAGE(Git)
IF (GIT_FOUND)
    EXEC_PROGRAM(${GIT_EXECUTABLE}
            ${CMAKE_SOURCE_DIR}
            ARGS "log -1 --format='%h'"
            OUTPUT_VARIABLE VERSION_HASH
            RETURN_VALUE RETURN)

    IF (RETURN EQUAL 0)
        MESSAGE(STATUS "Configure git: ${VERSION_HASH}")
        SET(PROJECT_PATCH ${VERSION_HASH})
    ENDIF (RETURN EQUAL 0)
ENDIF (GIT_FOUND)

SET(PACKAGE_VERSION "${PROJECT_MAJOR}.${PROJECT_MINOR}.${PROJECT_PATCH}")

IF (WIN32)
    ADD_DEFINITIONS(-DDOCDIR=".")
ELSE (WIN32)
    SET(SYSCONFDIR
            "/etc"
            CACHE PATH
            "Directory for system configuration of apvlv [/etc]"
            )
    ADD_DEFINITIONS(-DSYSCONFDIR="${SYSCONFDIR}")

    SET(DOCDIR
            "${CMAKE_INSTALL_PREFIX}/share/doc/apvlv"
            CACHE PATH
            "Directory for documentations of apvlv [PREFIX/share/doc/apvlv]"
            )
    ADD_DEFINITIONS(-DDOCDIR="${DOCDIR}")

    SET(LIBDIR
            "${CMAKE_INSTALL_PREFIX}/lib/apvlv"
            CACHE PATH
            "Directory for lib of apvlv [PREFIX/lib/apvlv]"
            )
    ADD_DEFINITIONS(-DLIBDIR="${LIBDIR}")

    SET(PIXMAPDIR
            "${CMAKE_INSTALL_PREFIX}/share/pixmaps/apvlv"
            CACHE PATH
            "Directory for pixmaps of apvlv [PREFIX/share/pixmaps/apvlv]"
            )
    ADD_DEFINITIONS(-DPIXMAPDIR="${PIXMAPDIR}")

    SET(APPLICATIONSDIR
            "${CMAKE_INSTALL_PREFIX}/share/applications"
            CACHE PATH
            "Directory for desktop file of apvlv [PREFIX/share/applications]"
            )
ENDIF (WIN32)

ADD_DEFINITIONS(-DPACKAGE_NAME="apvlv"
        -DPACKAGE_VERSION="${PACKAGE_VERSION}"
        -DPACKAGE_BUGREPORT="Alf <naihe2010@126.com>"
        -DRELEASE="rel"
        )

ADD_SUBDIRECTORY(src)

IF (WIN32)
    INSTALL(FILES apvlvrc.example DESTINATION "."
            RENAME _apvlvrc)
    INSTALL(FILES apvlvrc.example Startup.pdf main_menubar.glade DESTINATION ".")
    INSTALL(DIRECTORY icons DESTINATION ".")
    INSTALL(DIRECTORY ${CMAKE_HOME_DIRECTORY}/win32/poppler-data DESTINATION ".")
ELSE (WIN32)
    ADD_CUSTOM_TARGET(Startup.pdf
            ALL
            COMMAND "man" "-t" "${CMAKE_SOURCE_DIR}/apvlv.1" "|" "ps2pdf" "-" "${CMAKE_SOURCE_DIR}/Startup.pdf"
            DEPENDS apvlv.1)
    INSTALL(FILES apvlvrc.example DESTINATION ${SYSCONFDIR}
            RENAME apvlvrc)
    INSTALL(FILES apvlvrc.example Startup.pdf main_menubar.glade DESTINATION ${DOCDIR})
    INSTALL(DIRECTORY icons DESTINATION ${DOCDIR})
    INSTALL(FILES apvlv.1 TYPE MAN)
    INSTALL(FILES apvlv.desktop DESTINATION ${APPLICATIONSDIR})
ENDIF (WIN32)

SET(CPACK_PACKAGE_VENDOR "Alf")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "apvlv - Alf's PDF/DJVU/EPUB Viewer like Vim")
SET(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_MAJOR})
SET(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_MINOR})
SET(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_PATCH})

IF (UNIX)
    SET(CPACK_SET_DESTDIR ON)
    SET(CPACK_PACKAGE_CONTACT "Alf <naihe2010@126.com>")
    SET(CPACK_GENERATOR DEB)
    SET(CPACK_DEBIAN_PACKAGE_DEPENDS
            "libpoppler-glib8 (>= 0.8.7-4), poppler-data (>= 0.2.0-2)")
    IF (EXISTS "/etc/redhat-release")
        SET(CPACK_GENERATOR RPM)
        SET(CPACK_RPM_PACKAGE_REQUIRES "gtk3")
    ENDIF ()
    SET(CPACK_SOURCE_GENERATOR TGZ)
    SET(CPACK_SOURCE_IGNORE_FILES
            ${CMAKE_BINARY_DIR}
            ".git"
            ".gitignore"
            "win32"
            "~$"
            )
ELSE (UNIX)
    SET(CPACK_GENERATOR NSIS)
    SET(CPACK_NSIS_CONTACT "Alf <naihe2010@126.com>")
    SET(CPACK_NSIS_EXTRA_INSTALL_COMMANDS "CreateShortCut '\$DESKTOP\\\\apvlv.lnk' '\$INSTDIR\\\\apvlv.exe'")
    SET(CPACK_NSIS_EXTRA_UNINSTALL_COMMANDS "Delete '\$DESKTOP\\\\gsftc.lnk'")
ENDIF (UNIX)

INCLUDE(CPack)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -56,7 +56,7 @@
         ApvlvFile.h
         ApvlvPdf.h
         ApvlvInfo.h
-        ApvlvMenuAndTool.h
+        ApvlvMenu.h
         ApvlvParams.h
         ApvlvUtil.h
         ApvlvView.h
@@ -74,7 +74,7 @@
         ApvlvFile.cc
         ApvlvPdf.cc
         ApvlvInfo.cc
-        ApvlvMenuAndTool.cc
+        ApvlvMenu.cc
         ApvlvParams.cc
         ApvlvUtil.cc
         ApvlvView.cc

=== debian/changelog ===
apvlv (0.5.0+repack-2build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:18:46 +1100

apvlv (0.5.0+repack-2build2) noble; urgency=medium

  * No-change rebuild against .

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 22 Mar 2024 09:34:04 +1300

apvlv (0.5.0+repack-2build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 03:49:21 +0000

apvlv (0.5.0+repack-2) unstable; urgency=medium

  [ Jeremy Bícha ]
  * Build with webkit2gtk 4.1

  [ xiao sheng wen ]
  * d/copyright: update year info to 2024

 -- xiao sheng wen <atzlinux@sina.com>  Thu, 04 Jan 2024 10:24:02 +0800

apvlv (0.5.0+repack-1) unstable; urgency=medium

  * New upstream version 0.5.0+repack
  * Refresh debian/patches
  * d/rules: rm usr/share/man/apvlv.1, which has wrong man path
  * delete d/apvlv.xpm, useless,
    new upstream apvlv.desktop use Icon=x-office-document
  * d/copyright: remove unused debian/apvlv.xpm file info
  * Update d/dirs, match d/rules execute_after_dh_auto_install target

 -- xiao sheng wen <atzlinux@sina.com>  Mon, 28 Aug 2023 18:52:06 +0800

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: apvlv
 Section: text
 Priority: optional
-Maintainer: xiao sheng wen <atzlinux@sina.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: xiao sheng wen <atzlinux@sina.com>
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
@@ -11,7 +12,7 @@
  libgtk-3-dev,
  libpoppler-glib-dev,
  libpoppler-private-dev,
- libwebkit2gtk-4.0-dev,
+ libwebkit2gtk-4.1-dev,
  libxml2-dev,
  mandoc,
 Standards-Version: 4.6.2

=== debian/watch ===
version=4
opts="dversionmangle=s/\+repack\d*$//, repacksuffix=+repack" \
https://github.com/naihe2010/apvlv/tags \
(?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate

## apvlv 0.5.0-final+repack

=== debian/changelog ===
apvlv (0.5.0-final+repack-1) unstable; urgency=medium

  * New upstream version
  * Add salsa-ci file (routine-update)
  * d/gbp.conf: delete some lines which is gbp's default setting value

 -- xiao sheng wen <atzlinux@sina.com>  Sat, 15 Jun 2024 15:04:48 +0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: apvlv
 Section: text
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: xiao sheng wen <atzlinux@sina.com>
+Maintainer: xiao sheng wen <atzlinux@sina.com>
 Build-Depends:
  cmake,
  debhelper-compat (= 13),

## apvlv 0.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 3.1)
-SET(CMAKE_CXX_STANDARD 11)
+SET(CMAKE_CXX_STANDARD 17)
 SET(CMAKE_EXPORT_COMPILE_COMMANDS 1)
 
 PROJECT(apvlv)
 
 SET(PROJECT_MAJOR "0")
-SET(PROJECT_MINOR "5")
+SET(PROJECT_MINOR "6")
 SET(PROJECT_PATCH "0")
 FIND_PACKAGE(Git)
 IF (GIT_FOUND)
@@ -30,42 +30,42 @@
             "/etc"
             CACHE PATH
             "Directory for system configuration of apvlv [/etc]"
-            )
+    )
     ADD_DEFINITIONS(-DSYSCONFDIR="${SYSCONFDIR}")
 
     SET(DOCDIR
             "${CMAKE_INSTALL_PREFIX}/share/doc/apvlv"
             CACHE PATH
             "Directory for documentations of apvlv [PREFIX/share/doc/apvlv]"
-            )
+    )
     ADD_DEFINITIONS(-DDOCDIR="${DOCDIR}")
 
     SET(LIBDIR
             "${CMAKE_INSTALL_PREFIX}/lib/apvlv"
             CACHE PATH
             "Directory for lib of apvlv [PREFIX/lib/apvlv]"
-            )
+    )
     ADD_DEFINITIONS(-DLIBDIR="${LIBDIR}")
 
     SET(PIXMAPDIR
             "${CMAKE_INSTALL_PREFIX}/share/pixmaps/apvlv"
             CACHE PATH
             "Directory for pixmaps of apvlv [PREFIX/share/pixmaps/apvlv]"
-            )
+    )
     ADD_DEFINITIONS(-DPIXMAPDIR="${PIXMAPDIR}")
 
     SET(APPLICATIONSDIR
             "${CMAKE_INSTALL_PREFIX}/share/applications"
             CACHE PATH
             "Directory for desktop file of apvlv [PREFIX/share/applications]"
-            )
+    )
 ENDIF (WIN32)
 
 ADD_DEFINITIONS(-DPACKAGE_NAME="apvlv"
         -DPACKAGE_VERSION="${PACKAGE_VERSION}"
         -DPACKAGE_BUGREPORT="Alf <naihe2010@126.com>"
         -DRELEASE="rel"
-        )
+)
 
 ADD_SUBDIRECTORY(src)
 
@@ -111,7 +111,7 @@
             ".gitignore"
             "win32"
             "~$"
-            )
+    )
 ELSE (UNIX)
     SET(CPACK_GENERATOR NSIS)
     SET(CPACK_NSIS_CONTACT "Alf <naihe2010@126.com>")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-ADD_COMPILE_OPTIONS(-std=c++11)
+ADD_COMPILE_OPTIONS(-std=c++17)
 
 IF (WIN32)
     ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)
@@ -21,8 +21,8 @@
 PKG_CHECK_MODULES(LIBXML libxml-2.0 REQUIRED)
 PKG_CHECK_MODULES(WEBKIT webkit2gtk-4.1)
 if (NOT WEBKIT_FOUND)
-  PKG_CHECK_MODULES(WEBKIT webkit2gtk-4.0 REQUIRED)
-endif()
+    PKG_CHECK_MODULES(WEBKIT webkit2gtk-4.0 REQUIRED)
+endif ()
 INCLUDE_DIRECTORIES(${FREETYPE2_INCLUDE_DIRS}
         ${GTK_INCLUDE_DIRS}
         ${GLIB2_INCLUDE_DIRS}
@@ -56,7 +56,7 @@
         ApvlvFile.h
         ApvlvPdf.h
         ApvlvInfo.h
-        ApvlvMenu.h
+        ApvlvMenuAndTool.h
         ApvlvParams.h
         ApvlvUtil.h
         ApvlvView.h
@@ -64,8 +64,11 @@
         ApvlvCompletion.h
         ApvlvHtm.h
         ApvlvEpub.h
+        ApvlvTxt.h
+        ApvlvFb2.h
         ApvlvContent.h
-        )
+        ApvlvLab.h
+)
 
 SET(SOURCES
         ApvlvCmds.cc
@@ -74,7 +77,7 @@
         ApvlvFile.cc
         ApvlvPdf.cc
         ApvlvInfo.cc
-        ApvlvMenu.cc
+        ApvlvMenuAndTool.cc
         ApvlvParams.cc
         ApvlvUtil.cc
         ApvlvView.cc
@@ -82,9 +85,12 @@
         ApvlvCompletion.cc
         ApvlvHtm.cc
         ApvlvEpub.cc
+        ApvlvTxt.cc
+        ApvlvFb2.cc
         ApvlvContent.cc
+        ApvlvLab.cc
         main.cc
-        )
+)
 
 OPTION(APVLV_WITH_DJVU "If build apvlv with djvu format support." OFF)
 IF (APVLV_WITH_DJVU)
@@ -105,14 +111,6 @@
     SET(HEADERS ${HEADERS} ApvlvDjvu.h)
     SET(SOURCES ${SOURCES} ApvlvDjvu.cc)
 ENDIF (APVLV_WITH_DJVU)
-
-OPTION(APVLV_WITH_TXT "If build binary with txt format support." OFF)
-IF (APVLV_WITH_TXT)
-    ADD_DEFINITIONS(-DAPVLV_WITH_TXT)
-
-    SET(HEADERS ${HEADERS} ApvlvTxt.h)
-    SET(SOURCES ${SOURCES} ApvlvTxt.cc)
-ENDIF (APVLV_WITH_TXT)
 
 ADD_EXECUTABLE(apvlv ${HEADERS} ${SOURCES})

## apvlv 0.6.0-final+repack

=== debian/changelog ===
apvlv (0.6.0-final+repack-1) unstable; urgency=medium

  * New upstream version
  * d/control:
      - Bump Standards-Version: 4.7.0, no change needed
      - update Description and long Description

 -- xiao sheng wen <atzlinux@sina.com>  Thu, 08 Aug 2024 19:15:31 +0800

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  libwebkit2gtk-4.1-dev,
  libxml2-dev,
  mandoc,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://naihe2010.github.io/apvlv/
 Vcs-Git: https://salsa.debian.org/debian/apvlv.git
@@ -29,9 +29,9 @@
  pdf-viewer,
 Suggests:
  poppler-data,
-Description: PDF viewer with Vim-like behaviour
- apvlv (Alf's PDF Viewer Like Vim) is a small and fast PDF viewer, that uses
- poppler for rendering. Its interface aims to users who like vim behaviour.
+Description: PDF/EPUB/TXT/FB2 viewer with Vim-like behaviour
+ apvlv (Alf's PDF Viewer Like Vim) is a small and fast PDF/EPUB/TXT/FB2 viewer,
+ that uses poppler for rendering. Its interface aims to users who like vim
+ behaviour.
  For example opening a PDF file can be done with ':o filename'. apvlv can also
- work with tabs, so you can open multiple files at the same time in one
- program.
+ work with tabs, so you can open multiple files at the same time in one program.

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,7 @@
 #!/usr/bin/make -f
+
+# Uncomment this to turn on verbose mode.
+#export DH_VERBOSE=1
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
@@ -33,3 +36,4 @@
 	mv debian/apvlv/usr/share/doc/apvlv/main_menubar.glade \
 		debian/apvlv/usr/lib/apvlv/
 	rm -r debian/apvlv/usr/share/doc/apvlv/icons/
+	rm -fv debian/apvlv/usr/share/man/apvlv.1

## apvlv 0.7.0

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.5)
SET(CMAKE_CXX_STANDARD 20)
SET(CMAKE_EXPORT_COMPILE_COMMANDS 1)

PROJECT(apvlv)

SET(PROJECT_MAJOR "0")
SET(PROJECT_MINOR "7")
SET(PROJECT_PATCH "0")
FIND_PACKAGE(Git)
IF (GIT_FOUND)
    EXECUTE_PROCESS(COMMAND ${GIT_EXECUTABLE}
            log -1 --format=%h
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            OUTPUT_VARIABLE VERSION_HASH
            OUTPUT_STRIP_TRAILING_WHITESPACE
    )

    IF (NOT VERSION_HASH STREQUAL "")
        MESSAGE(STATUS "Configure git: ${VERSION_HASH}")
        SET(PROJECT_PATCH ${VERSION_HASH})
    ENDIF ()
ENDIF (GIT_FOUND)

SET(PACKAGE_VERSION "${PROJECT_MAJOR}.${PROJECT_MINOR}.${PROJECT_PATCH}")

SET(SYSCONFDIR
        "/etc"
        CACHE PATH
        "Directory for system configuration of apvlv [/etc]"
)
ADD_DEFINITIONS(-DSYSCONFDIR="${SYSCONFDIR}")

ADD_DEFINITIONS(-DPACKAGE_NAME="apvlv"
        -DPACKAGE_VERSION="${PACKAGE_VERSION}"
        -DPACKAGE_BUGREPORT="Alf <naihe2010@126.com>"
        -DRELEASE="rel"
)

ADD_SUBDIRECTORY(src)

INSTALL(DIRECTORY share DESTINATION ".")
IF (WIN32)
    INSTALL(FILES apvlvrc.example DESTINATION ".")
ELSE (WIN32)
    ADD_CUSTOM_TARGET(Startup.pdf
            ALL
            COMMAND "man" "-t" "${CMAKE_SOURCE_DIR}/apvlv.1" "|" "ps2pdf" "-" "${CMAKE_SOURCE_DIR}/share/doc/apvlv/Startup.pdf"
            DEPENDS apvlv.1)
    INSTALL(FILES apvlvrc.example DESTINATION ${SYSCONFDIR})
    INSTALL(FILES apvlv.1 TYPE MAN)
ENDIF (WIN32)

SET(CPACK_PACKAGE_VENDOR "Alf")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "apvlv - Alf's PDF/DJVU/EPUB Viewer like Vim")
SET(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_MAJOR})
SET(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_MINOR})
SET(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_PATCH})

IF (UNIX)
    SET(CPACK_SET_DESTDIR ON)
    SET(CPACK_PACKAGE_CONTACT "Alf <naihe2010@126.com>")
    SET(CPACK_GENERATOR DEB)
    SET(CPACK_DEBIAN_PACKAGE_DEPENDS
            "qt6 poppler-qt6 quazip")
    IF (EXISTS "/etc/redhat-release")
        SET(CPACK_GENERATOR RPM)
        SET(CPACK_RPM_PACKAGE_REQUIRES "qt6-qtwebengine poppler-qt6 quazip-qt6")
    ENDIF ()
    SET(CPACK_SOURCE_GENERATOR TGZ)
    SET(CPACK_SOURCE_IGNORE_FILES
            ${CMAKE_BINARY_DIR}
            ".git"
            ".gitignore"
            "win32"
            "~$"
    )
ELSE (UNIX)
    SET(CPACK_GENERATOR NSIS)
    SET(CPACK_NSIS_CONTACT "Alf <naihe2010@126.com>")
    SET(CPACK_NSIS_EXTRA_INSTALL_COMMANDS "CreateShortCut '\$DESKTOP\\\\apvlv.lnk' '\$INSTDIR\\\\bin\\\\apvlv.exe'")
    SET(CPACK_NSIS_EXTRA_UNINSTALL_COMMANDS "Delete '\$DESKTOP\\\\apvlv.lnk'")
ENDIF (UNIX)

INCLUDE(CPack)

=== src/CMakeLists.txt ===
# compile options
IF (WIN32)
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)
ELSE ()
    SET(CMAKE_CXX_FLAGS "-std=c++20 -Wall -fno-strict-aliasing")

    IF (${CMAKE_BUILD_TYPE} STREQUAL Debug)
        SET(CMAKE_CXX_FLAGS "-D_DEBUG -g ${CMAKE_CXX_FLAGS}")
    ELSE ()
        SET(CMAKE_CXX_FLAGS "-O2 ${CMAKE_CXX_FLAGS}")
    ENDIF ()
ENDIF ()
MESSAGE("-- BUILD TYPE: ${CMAKE_BUILD_TYPE}")
MESSAGE("-- CXX FLAGS: ${CMAKE_CXX_FLAGS}")

OPTION(APVLV_WITH_MUPDF "If build binary with MuPDF." On)
IF (WIN32)
    OPTION(APVLV_WITH_POPPLER "If build binary with Poppler-Qt6." On)
ELSE ()
    OPTION(APVLV_WITH_POPPLER "If build binary with Poppler-Qt6." Off)
ENDIF ()

IF (WIN32)
    SET(Qt6_DIR "C:/Qt/6.7.2/msvc2019_64/lib/cmake/Qt6" CACHE STRING "Qt6config.cmake directory")
    SET(Qt6QmlTools_DIR "C:/Qt/6.7.2/msvc2019_64/lib/cmake/Qt6QmlTools" CACHE STRING "Qt6QmlToolsconfig.cmake directory")
    SET(Qt6AxContainer_DIR "C:/Qt/6.7.2/msvc2019_64/lib/cmake/Qt6AxContainer" CACHE STRING "Qt6config.cmake directory")
    SET(QUAZIP_INCLUDE_DIRS "C:/Qt/6.7.2/msvc2019_64/include/QuaZip-Qt6-1.4/quazip;C:/Qt/6.7.2/msvc2019_64/include" CACHE STRING "Quazip include directory")
    SET(QUAZIP_LIBRARY_DIRS "C:/Qt/6.7.2/msvc2019_64/lib" CACHE STRING "Quazip lib directory")
    SET(QUAZIP_LIBRARIES "C:/Qt/6.7.2/msvc2019_64/lib/quazip1-qt6.lib" CACHE STRING "Quazip library file")
    SET(DJVULIBRE_DIR "C:/Program Files (x86)/DjVuLibre" CACHE PATH "DjvuLibre dir")
    CMAKE_POLICY(SET CMP0010 NEW)
    CMAKE_POLICY(SET CMP0087 NEW)
ELSE ()
    FIND_PACKAGE(PkgConfig)
    IF (${APVLV_WITH_POPPLER})
        PKG_CHECK_MODULES(POPPLER poppler-qt6)
    ENDIF ()
    PKG_CHECK_MODULES(QUAZIP quazip1-qt6 REQUIRED)
ENDIF ()

FIND_PACKAGE(Qt6 NAMES Qt6 COMPONENTS Core Gui Widgets WebEngineWidgets Pdf PdfWidgets Xml PrintSupport REQUIRED)

SET(Qt_INCLUDE_DIRS
        ${Qt6Core_INCLUDE_DIRS}
        ${Qt6Gui_INCLUDE_DIRS}
        ${Qt6Widgets_INCLUDE_DIRS}
        ${Qt6WebEngineWidgets_INCLUDE_DIRS}
        ${Qt6Pdf_INCLUDE_DIRS}
        ${Qt6PdfWidgets_INCLUDE_DIRS}
        ${Qt6Xml_INCLUDE_DIRS}
        ${Qt6PrintSupport_INCLUDE_DIRS})
SET(Qt_LIBRARIES Qt6::Core Qt6::Gui Qt6::Widgets Qt6::WebEngineWidgets Qt6::Pdf Qt6::PdfWidgets Qt6::Xml Qt6::PrintSupport)
GET_FILENAME_COMPONENT(_qt_bin_dir "${WINDEPLOYQT_EXECUTABLE}" DIRECTORY)
MESSAGE("-- Qt6 binary directory: ${_qt_bin_dir}")

INCLUDE_DIRECTORIES(
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${QUAZIP_INCLUDE_DIRS}
        ${Qt_INCLUDE_DIRS})
LINK_DIRECTORIES(
        ${QUAZIP_LIBRARY_DIRS}
        ${Qt_LIBRARY_DIRS})
SET(APVLV_REQ_LIBRARIES
        ${QUAZIP_LIBRARIES}
        ${Qt_LIBRARIES})

ADD_DEFINITIONS(-DQT_MESSAGELOGCONTEXT)

PKG_CHECK_MODULES(CMARK libcmark REQUIRED)
INCLUDE_DIRECTORIES(${CMARK_INCLUDE_DIRS})
SET(APVLV_REQ_LIBRARIES ${CMARK_LIBRARIES} ${APVLV_REQ_LIBRARIES})

SET(HEADERS
        ApvlvCmds.h
        ApvlvFrame.h
        ApvlvFile.h
        ApvlvFileIndex.h
        ApvlvFileWidget.h
        ApvlvWidget.h
        ApvlvWeb.h
        ApvlvInfo.h
        ApvlvParams.h
        ApvlvUtil.h
        ApvlvView.h
        ApvlvWindow.h
        ApvlvCompletion.h
        ApvlvDirectory.h
        ApvlvLab.h
        ApvlvLog.h
        ApvlvSearch.h
        ApvlvSearchDialog.h
        ApvlvDired.h
        ApvlvQueue.h
        ApvlvImageWidget.h
        ApvlvWebViewWidget.h
        ApvlvEditor.h
        ApvlvNote.h
        ApvlvNoteWidget.h
        ApvlvMarkdown.h
        file/ApvlvHtm.h
        file/ApvlvImage.h
        file/ApvlvQtPdf.h
        file/ApvlvEpub.h
        file/ApvlvFb2.h
        file/ApvlvTxt.h
)

SET(SOURCES
        ApvlvCmds.cc
        ApvlvFrame.cc
        ApvlvFile.cc
        ApvlvFileIndex.cc
        ApvlvFileWidget.cc
        ApvlvWidget.cc
        ApvlvWeb.cc
        ApvlvInfo.cc
        ApvlvParams.cc
        ApvlvUtil.cc
        ApvlvView.cc
        ApvlvWindow.cc
        ApvlvCompletion.cc
        ApvlvDirectory.cc
        ApvlvLab.cc
        ApvlvLog.cc
        ApvlvSearch.cc
        ApvlvSearchDialog.cc
        ApvlvDired.cc
        ApvlvQueue.cc
        ApvlvImageWidget.cc
        ApvlvWebViewWidget.cc
        ApvlvEditor.cc
        ApvlvNote.cc
        ApvlvNoteWidget.cc
        ApvlvMarkdown.cc
        file/ApvlvHtm.cc
        file/ApvlvImage.cc
        file/ApvlvQtPdf.cc
        file/ApvlvEpub.cc
        file/ApvlvFb2.cc
        file/ApvlvTxt.cc
        main.cc
)

MESSAGE("-- will build Web as epub engine")
MESSAGE("-- will build Web as fb2 engine")
MESSAGE("-- will build QtPdf as pdf engine")

IF (${APVLV_WITH_MUPDF})
    MESSAGE("-- will build MuPDF as pdf engine")
    SET(HEADERS ${HEADERS} file/ApvlvMuPdf.h)
    SET(SOURCES ${SOURCES} file/ApvlvMuPdf.cc)
    IF (WIN32)
        SET(APVLV_REQ_LIBRARIES mupdf.lib ${APVLV_REQ_LIBRARIES})
    ELSE ()
        PKG_CHECK_MODULES(MUPDF mupdf)
        IF (MUPDF_FOUND)
            MESSAGE(STATUS "mupdf libraries: ${MUPDF_STATIC_LIBRARIES}")
            SET(APVLV_REQ_LIBRARIES ${MUPDF_STATIC_LIBRARIES} -lharfbuzz ${APVLV_REQ_LIBRARIES})
        ELSE ()
            MESSAGE(STATUS "mupdf libraries: -lmupdf")
            SET(APVLV_REQ_LIBRARIES -lmupdf ${APVLV_REQ_LIBRARIES})
        ENDIF ()
    ENDIF ()
ENDIF ()

IF (${APVLV_WITH_POPPLER})
    MESSAGE("-- will build Poppler as pdf engine")
    SET(HEADERS ${HEADERS} file/ApvlvPopplerPdf.h)
    SET(SOURCES ${SOURCES} file/ApvlvPopplerPdf.cc)
    INCLUDE_DIRECTORIES(${POPPLER_INCLUDE_DIRS})
    LINK_DIRECTORIES(${POPPLER_LIBRARY_DIRS})
    SET(APVLV_REQ_LIBRARIES ${POPPLER_LIBRARIES} ${APVLV_REQ_LIBRARIES})
ENDIF ()

OPTION(APVLV_WITH_DJVU "If build apvlv with djvu format support." ON)
IF (APVLV_WITH_DJVU)
    MESSAGE("-- will build djvulibre as djvu engine")
    IF (WIN32)
        INCLUDE_DIRECTORIES(${DJVULIBRE_DIR}/include)
        LINK_DIRECTORIES(${DJVULIBRE_DIR})
        SET(APVLV_REQ_LIBRARIES libdjvulibre.lib
                ${APVLV_REQ_LIBRARIES})
    ELSE (WIN32)
        SET(APVLV_REQ_LIBRARIES -ldjvulibre
                ${APVLV_REQ_LIBRARIES})
    ENDIF (WIN32)

    SET(HEADERS ${HEADERS} file/ApvlvDjvu.h)
    SET(SOURCES ${SOURCES} file/ApvlvDjvu.cc)
ENDIF (APVLV_WITH_DJVU)

OPTION(APVLV_WITH_OFFICE "If build apvlv with office format support." ON)
IF (APVLV_WITH_OFFICE)
    IF (WIN32)
        MESSAGE("-- will build MSOffice as office file engine")
        FIND_PACKAGE(Qt6AxContainer REQUIRED)
        INCLUDE_DIRECTORIES(${Qt6AxContainer_INCLUDE_DIRES})
        SET(APVLV_REQ_LIBRARIES ${Qt6AxContainer_LIBRARIES} Shlwapi.lib
                ${APVLV_REQ_LIBRARIES})
        SET(HEADERS ${HEADERS} file/ApvlvAxOffice.h)
        SET(SOURCES ${SOURCES} file/ApvlvAxOffice.cc)
    ELSE (WIN32)
        MESSAGE("-- will build libreOffice as office file engine")
        SET(APVLV_REQ_LIBRARIES -llibreofficekitgtk
                ${APVLV_REQ_LIBRARIES})
        ADD_DEFINITIONS(-DLIBO_INTERNAL_ONLY=1)
        SET(HEADERS ${HEADERS} file/ApvlvLibreOffice.h)
        SET(SOURCES ${SOURCES} file/ApvlvLibreOffice.cc)
    ENDIF (WIN32)
ENDIF (APVLV_WITH_OFFICE)

OPTION(APVLV_WITH_OCR "If build apvlv with OCR support." ON)
IF (${APVLV_WITH_OCR})
    ADD_DEFINITIONS(-DAPVLV_WITH_OCR)
    SET(HEADERS ${HEADERS} ApvlvOCR.h)
    SET(SOURCES ${SOURCES} ApvlvOCR.cc)

    IF (WIN32)
    ELSE ()
        MESSAGE("-- will build tesseract as OCR library")
        PKG_CHECK_MODULES(TESSERACT tesseract)
        INCLUDE_DIRECTORIES(${TESSERACT_INCLUDE_DIRS})
        LINK_DIRECTORIES(${TESSERACT_LIBRARY_DIRS})
        SET(APVLV_REQ_LIBRARIES ${TESSERACT_LIBRARIES}
                ${APVLV_REQ_LIBRARIES})
    ENDIF ()
ENDIF ()

MESSAGE("-- link libraries: ${APVLV_REQ_LIBRARIES}")
ADD_EXECUTABLE(apvlv ${HEADERS} ${SOURCES})
SET_PROPERTY(TARGET apvlv PROPERTY AUTOMOC ON)
TARGET_LINK_LIBRARIES(apvlv ${APVLV_REQ_LIBRARIES})

ADD_EXECUTABLE(testNote ApvlvNote.cc ApvlvMarkdown.cc testNote.cc)
SET_PROPERTY(TARGET testNote PROPERTY AUTOMOC ON)
TARGET_LINK_LIBRARIES(testNote ${APVLV_REQ_LIBRARIES})

# for debug
IF (WIN32)
    ADD_CUSTOM_COMMAND(TARGET apvlv POST_BUILD
            COMMAND ${CMAKE_COMMAND}
            "-E" copy_directory
            ${CMAKE_SOURCE_DIR}/share
            ${CMAKE_CURRENT_BINARY_DIR}/share)
    ADD_CUSTOM_COMMAND(TARGET apvlv POST_BUILD
            COMMAND "${CMAKE_COMMAND}" -E
            env PATH="${_qt_bin_dir}" "${WINDEPLOYQT_EXECUTABLE}"
            --verbose 0
            --dir "${CMAKE_CURRENT_BINARY_DIR}/Debug"
            $<TARGET_FILE:apvlv>
            COMMENT "Deploying Qt..."
    )
ELSE ()
    ADD_CUSTOM_COMMAND(TARGET apvlv POST_BUILD
            COMMAND ${CMAKE_COMMAND}
            "-E" remove_directory ${CMAKE_BINARY_DIR}/share
            COMMAND ${CMAKE_COMMAND}
            "-E" copy_directory ${CMAKE_SOURCE_DIR}/share
            ${CMAKE_BINARY_DIR}/share)
ENDIF ()

# translate
FIND_PROGRAM(LUPDATE lupdate HINTS "${_qt_bin_dir}")
FIND_PROGRAM(LRELEASE lrelease HINTS "${_qt_bin_dir}")
IF (${LUPDATE} STREQUAL "LUPDATE-NOTFOUND")
    FIND_PROGRAM(LUPDATE lupdate-qt6 HINTS "${_qt_bin_dir}")
    FIND_PROGRAM(LRELEASE lrelease-qt6 HINTS "${_qt_bin_dir}")
ENDIF ()
FILE(GLOB cppfiles *.cc)
ADD_CUSTOM_TARGET(apvlv_lupdate
        COMMAND ${LUPDATE}
        -locations none -target-language zh_CN
        ${cppfiles} -ts ${CMAKE_SOURCE_DIR}/zh_CN.ts)
ADD_CUSTOM_TARGET(apvlv_lrelease
        COMMAND ${LRELEASE}
        ${CMAKE_SOURCE_DIR}/zh_CN.ts
        -qm ${CMAKE_SOURCE_DIR}/share/doc/apvlv/translations/zh_CN.qm)
ADD_DEPENDENCIES(apvlv_lrelease apvlv_lupdate)
ADD_DEPENDENCIES(apvlv apvlv_lrelease)

INSTALL(TARGETS apvlv DESTINATION bin)

IF (WIN32)
    ADD_CUSTOM_COMMAND(TARGET apvlv POST_BUILD
            COMMAND "${CMAKE_COMMAND}" -E remove_directory "${CMAKE_CURRENT_BINARY_DIR}/winqt/"
            COMMAND "${CMAKE_COMMAND}" -E
            env PATH="${_qt_bin_dir}" "${WINDEPLOYQT_EXECUTABLE}"
            --release
            --verbose 0
            --no-compiler-runtime
            --no-opengl-sw
            --no-libraries
            --dir "${CMAKE_CURRENT_BINARY_DIR}/winqt/"
            $<TARGET_FILE:apvlv>
            COMMENT "Deploying Qt..."
    )

    INSTALL(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/winqt/" DESTINATION bin)

    INSTALL(CODE "set(MY_DEPENDENCY_PATHS \"$ENV{PATH}\" \"${_qt_bin_dir}\" )")

    INSTALL(CODE [[
    MESSAGE("-- get runtime dependencies ...")
    LIST(APPEND pre_exclude_regexes "api-ms-.*") # windows API
    LIST(APPEND pre_exclude_regexes "ext-ms-.*") # windows API
    LIST(APPEND pre_exclude_regexes "ieshims.dll") # windows API
    LIST(APPEND pre_exclude_regexes "emclient.dll") # windows API
    LIST(APPEND pre_exclude_regexes "devicelockhelpers.dll") # windows API

    LIST(APPEND post_exclude_regexes ".*WINDOWS[\\/]system32.*")

    FILE(GET_RUNTIME_DEPENDENCIES
      EXECUTABLES $<TARGET_FILE:apvlv>
      RESOLVED_DEPENDENCIES_VAR _r_deps
      UNRESOLVED_DEPENDENCIES_VAR _u_deps
      PRE_EXCLUDE_REGEXES ${pre_exclude_regexes}
      POST_EXCLUDE_REGEXES ${post_exclude_regexes}
      DIRECTORIES ${MY_DEPENDENCY_PATHS}
    )
    LIST(LENGTH _u_deps _u_length)
    IF("${_u_length}" GREATER 0)
      MESSAGE("Unresolved dependencies detected in [${MY_DEPENDENCY_PATHS}]!")
      FOREACH(_no ${_u_deps})
        MESSAGE("Can not find ${_no}")
      ENDFOREACH()
    ENDIF()
    FOREACH(_file ${_r_deps})
      MESSAGE("install " ${_file})
      FILE(INSTALL FILES "${_file}"
        DESTINATION "${CMAKE_INSTALL_PREFIX}/bin"
      )
    ENDFOREACH()
    ]])
ENDIF (WIN32)

## apvlv 0.7.0-alpha

=== debian/changelog ===
apvlv (0.7.0-alpha-2ubuntu2) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 27 May 2025 08:03:13 +0200

apvlv (0.7.0-alpha-2ubuntu1) plucky; urgency=medium

  * d/control: Add dependency on liblibreofficekitgtk to fix FTBFS.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 18 Feb 2025 09:43:51 +0000

apvlv (0.7.0-alpha-2build1) plucky; urgency=medium

  * No-change rebuild for libgumbo3.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 03 Feb 2025 17:59:45 +0000

apvlv (0.7.0-alpha-2) unstable; urgency=medium

  * d/control:
      - Recommends: add tesseract-ocr-chi-sim tesseract-ocr-eng
      - update Description, add MOBI/CBZ/HTML file type
  * d/rules:
      - dh_compress add -x.qm, don't compress qt translations files
      - execute_after_dh_auto_install target only deal with manpages
  * d/p/add-MUPDF_STATIC_LIBRARIES.patch: add Forwarded
        https://github.com/naihe2010/apvlv/issues/94

 -- xiao sheng wen <atzlinux@sina.com>  Wed, 25 Dec 2024 09:51:14 +0800

apvlv (0.7.0-alpha-1) unstable; urgency=medium

  * New upstream version 0.7.0-alpha
  * d/watch: not use repack opts
  * d/rules:
      - dh_auto_configure add -DCMAKE_PREFIX_PATH=/usr/lib/qt6
      - execute_before_dh_auto_build: add mkdir -pv share/doc/apvlv/translations
      - update execute_after_dh_auto_install
  * debian/patches:
      - rm 0006-restore-Debian-CXXFLAGS.patch
      - add add-MUPDF_STATIC_LIBRARIES.patch
  * d/control: update Build-Depends, new upstream use qt6, not use gtk
  * rm d/dirs, d/install, useless
  * d/copyright:
      - remove Files-Excluded: win32, new upstream had deleted this directory
      - delete icons/* setion and License CC-BY-SA-3.0 LGPL-3

 -- xiao sheng wen <atzlinux@sina.com>  Fri, 20 Dec 2024 09:19:03 +0800

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,31 @@
 Source: apvlv
 Section: text
 Priority: optional
-Maintainer: xiao sheng wen <atzlinux@sina.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: xiao sheng wen <atzlinux@sina.com>
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
  ghostscript,
  libdjvulibre-dev,
  libepub-dev,
- libgtk-3-dev,
+ libgumbo-dev,
+ libharfbuzz-dev,
+ libjbig2dec0-dev,
+ libmujs-dev,
+ libmupdf-dev,
+ libopenjp2-7-dev,
  libpoppler-glib-dev,
  libpoppler-private-dev,
- libwebkit2gtk-4.1-dev,
- libxml2-dev,
+ libquazip1-qt6-dev,
+ libreofficekit-dev,
+ libtesseract-dev,
  mandoc,
+ qt6-base-dev-tools,
+ qt6-l10n-tools,
+ qt6-pdf-dev,
+ qt6-webengine-dev,
+ liblibreofficekitgtk,
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://naihe2010.github.io/apvlv/
@@ -25,11 +37,14 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
+Recommends:
+ tesseract-ocr-chi-sim,
+ tesseract-ocr-eng,
 Provides:
  pdf-viewer,
 Suggests:
  poppler-data,
-Description: PDF/EPUB/TXT/FB2 viewer with Vim-like behaviour
+Description: PDF/EPUB/TXT/FB2/MOBI/CBZ/HTML ... viewer with Vim-like behaviour
  apvlv (Alf's PDF Viewer Like Vim) is a small and fast PDF/EPUB/TXT/FB2 viewer,
  that uses poppler for rendering. Its interface aims to users who like vim
  behaviour.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_PREFIX_PATH="/usr/lib/qt6" \

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_compress:
	dh_compress -XStartup.pdf -X.qm

execute_before_dh_auto_build:
	cp -v Startup.pdf debian/orig.Startup.pdf
	mkdir -pv share/doc/apvlv/translations

execute_before_dh_installdocs:
	mandoc -T pdf apvlv.1 > Startup.pdf

execute_after_dh_builddeb:
	mv -v debian/orig.Startup.pdf Startup.pdf

# cmake is a nice way to install this package's files, but it gets a
# few things wrong.  We run dh_auto_install and then tidy up.  Also
# see the d/manpages file.
execute_after_dh_auto_install:
	rm -fv debian/apvlv/usr/share/man/apvlv.1

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
    https://github.com/naihe2010/apvlv/tags \
    (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## apvlv 0.7.0-final

=== debian/changelog ===
apvlv (0.7.0-final-1) unstable; urgency=medium

  * New upstream version 0.7.0-final
  * rm d/p/add-MUPDF_STATIC_LIBRARIES.patch, new upstream applied
  * d/control: Build-Depends add libcmark-dev
  * d/copyright: fix old-fsf-address-in-copyright-file

 -- xiao sheng wen <atzlinux@sina.com>  Thu, 10 Apr 2025 08:43:52 +0800

apvlv (0.7.0-alpha-5) unstable; urgency=medium

  * add d/p/add-CXXFLAGS.patch, let blhc happy

 -- xiao sheng wen <atzlinux@sina.com>  Thu, 06 Mar 2025 16:03:27 +0800

apvlv (0.7.0-alpha-4) unstable; urgency=medium

  * fix typo in 0.7.0-alpha-3 changelog

 -- xiao sheng wen <atzlinux@sina.com>  Thu, 06 Mar 2025 15:52:06 +0800

apvlv (0.7.0-alpha-3) unstable; urgency=medium

  * Bump Standards-Version: 4.7.2
  * d/copyright: update year info to 2025
  * d/control: Build-Depends add liblibreofficekitgtk(Closes: #1099216)

 -- xiao sheng wen <atzlinux@sina.com>  Thu, 06 Mar 2025 13:20:00 +0800

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,18 @@
 Source: apvlv
 Section: text
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: xiao sheng wen <atzlinux@sina.com>
+Maintainer: xiao sheng wen <atzlinux@sina.com>
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
  ghostscript,
+ libcmark-dev,
  libdjvulibre-dev,
  libepub-dev,
  libgumbo-dev,
  libharfbuzz-dev,
  libjbig2dec0-dev,
+ liblibreofficekitgtk,
  libmujs-dev,
  libmupdf-dev,
  libopenjp2-7-dev,
@@ -25,8 +26,7 @@
  qt6-l10n-tools,
  qt6-pdf-dev,
  qt6-webengine-dev,
- liblibreofficekitgtk,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://naihe2010.github.io/apvlv/
 Vcs-Git: https://salsa.debian.org/debian/apvlv.git
